<?php

	/**
	 * Dieses Modul erlaubt die Zahlungsart "Kreditkarte"
	 * @author hartmut 
	 */
	class wpsg_mod_creditcard extends wpsg_mod_basic
	{
		
		var $lizenz = 2;
		var $id = 16;
		var $version = "4.4.10.8457";
		var $hilfeURL = 'http://wpshopgermany.de/?p=4634999';
		
		/**
		 * Costructor
		 */
		public function __construct() {
			
			parent::__construct();
			
			$this->name = __('Kreditkarte', 'wpsg');
			$this->group = __('Zahlungsarten', 'wpsg');
			$this->desc = __('Ermöglicht die Zahlungsart Kreditkarte.', 'wpsg');
						
		} // public function __construct()
		
		public function install() {
			 
			require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php');
			
			/**
			 * Bestelltabelle erweitern
			 */ 
			$sql = "CREATE TABLE ".WPSG_TBL_ORDER." (
		   		mod_creditcard_typ BLOB NOT NULL,
		   		mod_creditcard_inhaber BLOB NOT NULL,
		   		mod_creditcard_knr BLOB NOT NULL,
		   		mod_creditcard_pruefz BLOB NOT NULL,
		   		mod_creditcard_gueltigm BLOB NOT NULL,
				mod_creditcard_gueltigj BLOB NOT NULL
		   	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
   	   	 
   			dbDelta($sql);
   			
   			$this->shop->checkDefault('wpsg_mod_creditcard_bezeichnung', $this->name, false, true);
   			$this->shop->checkDefault('wpsg_mod_creditcard_aktiv', '1');
   			$this->shop->checkDefault('wpsg_mod_creditcard_hint', __('Wählen Sie diese Zahlungsart wenn sie uns eine Einzugsermächtigung für ihr Konto erteilen möchten. Wir benötigen dazu folgende Angaben:', 'wpsg'), false, true);
   			$this->shop->checkDefault('wpsg_mod_creditcard_gebuehr', '0');
   			$this->shop->checkDefault('wpsg_mod_creditcard_mwst', '0');
   			$this->shop->checkDefault('wpsg_mod_creditcard_mwstland', '0');
            $this->shop->checkDefault('wpsg_mod_creditcard_schluessel', wpsg_genCode(256));
			
		} // public function install()
		
		public function settings_edit()
		{
									
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_creditcard/settings_edit.phtml');
			
		}
		
		public function settings_save() {
			
		    $this->shop->update_option('wpsg_mod_creditcard_bezeichnung', $_REQUEST['wpsg_mod_creditcard_bezeichnung'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_creditcard_aktiv', $_REQUEST['wpsg_mod_creditcard_aktiv'], false, false, WPSG_SANITIZE_CHECKBOX);
			$this->shop->update_option('wpsg_mod_creditcard_hint', $_REQUEST['wpsg_mod_creditcard_hint'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_creditcard_gebuehr', $_REQUEST['wpsg_mod_creditcard_gebuehr'], false, false, WPSG_SANITIZE_FLOAT);
			$this->shop->update_option('wpsg_mod_creditcard_mwst', $_REQUEST['wpsg_mod_creditcard_mwst'], false, false, WPSG_SANITIZE_TAXKEY);
			$this->shop->update_option('wpsg_mod_creditcard_mwstland', $_REQUEST['wpsg_mod_creditcard_mwstland'], false, false, WPSG_SANITIZE_CHECKBOX);
			$this->shop->update_option('wpsg_mod_creditcard_schluessel', $_REQUEST['wpsg_mod_creditcard_schluessel'], false, false, WPSG_SANITIZE_TEXTFIELD);

		} // public function settings_save()
	
		public function addPayment(&$arPayment) {

			if (is_admin() || $this->shop->get_option('wpsg_mod_creditcard_aktiv') == '1') {
				
				$this->shop->view['error'] = $this->shop->view['error']??[];
				
				$this->shop->view['wpsg_mod_creditcard'] = [
					'typ' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_typ']),
					'inhaber' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_inhaber']),
					'knr' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_knr']),
					'pruefz' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_pruefz']),
					'gueltigm' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_gueltigm']),
					'gueltigj' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_gueltigj'])
				];
				 
				$arPayment[$this->id] = array(
					'id' => $this->id,
					'name' => __($this->shop->get_option('wpsg_mod_creditcard_bezeichnung'), 'wpsg'),
					'price' => $this->shop->get_option('wpsg_mod_creditcard_gebuehr'),
					'tax_key' => $this->shop->get_option('wpsg_mod_creditcard_mwst'),
					'mwst_null' => $this->shop->get_option('wpsg_mod_creditcard_mwstland'),
					//'hint' => __($this->shop->get_option('wpsg_mod_creditcard_hint')),
					'hint' => $this->shop->render(WPSG_PATH_VIEW.'mods/mod_creditcard/paymenthint.phtml', false),
					'logo' => $this->shop->getRessourceURL('mods/mod_creditcard/gfx/logo_100x25.png')
				);
							
			}
			
		} // public function addPayment(&$arPayment)
			
		public function checkCheckout(&$state, &$error, &$arCheckout)  { 

			if (wpsg_isSizedString($arCheckout['payment'])) {

				if ($arCheckout['payment'] != $this->id) return;
				
			}
	 
			// Werte in die Session und den Checkout schreiben schreiben
			if (
					(isset($_REQUEST['wpsg_checkout']) && wpsg_isSizedArray($_REQUEST['wpsg_mod_creditcard'])) || 
					(isset($_REQUEST['wpsg_checkout2']) && wpsg_isSizedArray($_REQUEST['wpsg_mod_creditcard']))
			)
			{
		 
				$_SESSION['wpsg']['checkout']['mod_creditcard_typ'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['typ']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_pruefz'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['pruefz']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_gueltigm'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['gueltigm']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_gueltigj'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['gueltigj']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_inhaber'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['inhaber']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_knr'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['knr']);
				
				$arCheckout['mod_creditcard_typ'] = $_SESSION['wpsg']['checkout']['mod_creditcard_typ'];
				$arCheckout['mod_creditcard_pruefz'] = $_SESSION['wpsg']['checkout']['mod_creditcard_pruefz'];
				$arCheckout['mod_creditcard_gueltigm'] = $_SESSION['wpsg']['checkout']['mod_creditcard_gueltigm'];
				$arCheckout['mod_creditcard_gueltigj'] = $_SESSION['wpsg']['checkout']['mod_creditcard_gueltigj'];
				$arCheckout['mod_creditcard_inhaber'] = $_SESSION['wpsg']['checkout']['mod_creditcard_inhaber'];
				$arCheckout['mod_creditcard_knr'] = $_SESSION['wpsg']['checkout']['mod_creditcard_knr'];

			}

			if ( 
					(($state > 1) ||
					($state >= 1 && $this->shop->hasMod('wpsg_mod_onepagecheckout'))) &&
					(isset($_REQUEST['wpsg_checkout']) || isset($_REQUEST['wpsg_checkout2']))
				)
			{
						
				if (trim($arCheckout['mod_creditcard_typ']) == '') { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_typ'; $this->shop->addFrontendError(__('Bitte den Namen der Kreditkarte kontrollieren (Kreditkarte)', 'wpsg')); $error = true; }
				if (trim($arCheckout['mod_creditcard_inhaber']) == '') { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_inhaber'; $this->shop->addFrontendError(__('Bitte den Inhaber des Kontos kontrollieren (Kreditkarte)', 'wpsg')); $error = true; }
				

				if (trim($arCheckout['mod_creditcard_pruefz']) == '') { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_pruefz'; $this->shop->addFrontendError(__('Bitte die Prüfziffer kontrollieren (Kreditkarte)', 'wpsg')); $error = true; }
				if (trim($arCheckout['mod_creditcard_knr']) == '') { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_knr'; $this->shop->addFrontendError(__('Bitte die Kartennummer überprüfen (Kreditkarte)', 'wpsg')); $error = true; }
				
				if (strlen(trim($arCheckout['mod_creditcard_pruefz'])) != 3) { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_pruefz'; $this->shop->addFrontendError(__('Bitte die Prüfziffer kontrollieren (Kreditkarte)', 'wpsg')); $error = true; }
				
				// Kartennummer prüfen
				$typ = trim($arCheckout['mod_creditcard_typ']);
				$knr = trim($arCheckout['mod_creditcard_knr']);

				if ($this->checkCreditCardNumber($typ, $knr) == false) { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_knr'; $this->shop->addFrontendError(__('Bitte die Kartennummer überprüfen (Kreditkarte)', 'wpsg')); $error = true; }

			}
			
		} // public function checkCheckout(&$state, &$error, &$arCheckout)
		
		private function checkCreditCardNumber($typ, $knr)
		{
			$knr = str_replace(" ", "", $knr);
			$bb = true;
			
			if (!is_int($knr) == false)
			{
				return false;
			}
			$a1 = substr($knr, 0, 1);
			$ai = intval(substr($knr, 15, 1), 10);
			if (!((($a1 == "4") && ($typ == "VISA")) || (($a1 == "5") && ($typ == "MasterCard"))))
			{
				$bb = false;
			}
			$sum = 0;
			$k = 2;
			for ($i = 14; $i >= 0; $i--) {
				$dig = $k * intval(substr($knr, $i, 1), 10);
				if ($dig > 9) { $dig = $dig - 9;}
				$sum = $sum + $dig;
				//$sum = $sum + $k * intval(substr($knr, $i, 1), 10);
				if ($k == 2) { $k = 1; } else { $k = 2; }
			}
			$sum = $sum % 10;
			if ($sum > 0) { $sum = 10 - $sum; }
			if ($sum != $ai) { $bb = false; }
			
			return $bb;	
			
		}
		
		public function calculation_saveOrder(&$oCalculation, $arCalculation, &$db_data, $finish_order) { 
			
			if ($_SESSION['wpsg']['checkout']['payment'] == $this->id) {
				
				$checkout = $_SESSION['wpsg']['checkout'];
				
				// Daten in die Bestelltabelle hinzutragen

                /* Alter Algorithmus < PHP 7.1
				//AES256
				//string mcrypt_encrypt ( string $cipher , string $key , string $data , string $mode [, string $iv ] )
				$key = $this->shop->get_option("wpsg_mod_creditcard_schluessel");

				$iv = mcrypt_create_iv(16, MCRYPT_RAND);
				
				//echo wpsg_q($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_typ'], MCRYPT_MODE_CBC, $iv));
				
				$db_data['mod_creditcard_typ'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_typ'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_pruefz'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_pruefz'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_gueltigm'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_gueltigm'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_gueltigj'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_gueltigj'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_inhaber'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_inhaber'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_knr'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_knr'], MCRYPT_MODE_CBC, $iv));
				*/

                $key = $this->shop->get_option("wpsg_mod_creditcard_schluessel");
                $iv = random_bytes(16);
                $encrypt_method = "AES-256-CBC";

                $db_data['mod_creditcard_typ'] = wpsg_q($iv.'|'.$encrypt_method.'|'.openssl_encrypt($checkout['mod_creditcard_typ'], $encrypt_method, $key, 0, $iv));
                $db_data['mod_creditcard_pruefz'] = wpsg_q($iv.'|'.$encrypt_method.'|'.openssl_encrypt($checkout['mod_creditcard_pruefz'], $encrypt_method, $key, 0, $iv));
                $db_data['mod_creditcard_gueltigm'] = wpsg_q($iv.'|'.$encrypt_method.'|'.openssl_encrypt($checkout['mod_creditcard_gueltigm'], $encrypt_method, $key, 0, $iv));
                $db_data['mod_creditcard_gueltigj'] = wpsg_q($iv.'|'.$encrypt_method.'|'.openssl_encrypt($checkout['mod_creditcard_gueltigj'], $encrypt_method, $key, 0, $iv));
                $db_data['mod_creditcard_inhaber'] = wpsg_q($iv.'|'.$encrypt_method.'|'.openssl_encrypt($checkout['mod_creditcard_inhaber'], $encrypt_method, $key, 0, $iv));
                $db_data['mod_creditcard_knr'] = wpsg_q($iv.'|'.$encrypt_method.'|'.openssl_encrypt($checkout['mod_creditcard_knr'], $encrypt_method, $key, 0, $iv));

			}
						
		}
		 
		public function order_view_afterpayment(&$order_id) {
									
			$order_data = $this->shop->cache->loadOrder($order_id);
			
			if ($order_data['type_payment'] != $this->id) return;
			
			$this->shop->view['wpsg_mod_creditcard']['typ'] = $this->decrypt($order_data['mod_creditcard_typ']);
			$this->shop->view['wpsg_mod_creditcard']['pruefz'] = $this->decrypt($order_data['mod_creditcard_pruefz']);
			$this->shop->view['wpsg_mod_creditcard']['gueltigm'] = $this->decrypt($order_data['mod_creditcard_gueltigm']);
			$this->shop->view['wpsg_mod_creditcard']['gueltigj'] = $this->decrypt($order_data['mod_creditcard_gueltigj']);
		    $this->shop->view['wpsg_mod_creditcard']['inhaber'] = $this->decrypt($order_data['mod_creditcard_inhaber']);
			$this->shop->view['wpsg_mod_creditcard']['knr'] = $this->decrypt($order_data['mod_creditcard_knr']);
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_creditcard/order_view_afterpayment.phtml');
			
		} // public function order_view_afterpayment(&$order_id)

		/**
		 * Export der Daten als CSV
		 * {@inheritDoc}
		 * @see wpsg_mod_basic::wpsg_mod_export_loadFields()
		 */
		public function wpsg_mod_export_loadFields(&$arFields) {

			$arFields[10]['fields']['mod_creditcard_typ'] = __('Kreditkartentyp', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_inhaber'] = __('Kreditkarteninhaber', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_knr'] = __('Kreditkartennummer', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_pruefz'] = __('Kreditkartenprüfziffer', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_gueltigm'] = __('Kreditkarten-Gültigkeit-Monat', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_gueltigj'] = __('Kreditkarten-Gültigkeit-Jahr', 'wpsg');
				
		} // public function wpsg_mod_export_loadFields(&$arFields)
		
		public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $order_product_id, $profil_separator) {
			
			$arOrder = $this->shop->cache->loadOrder($o_id);
			$value = "";

			switch ($field_value) {

                case 'mod_creditcard_typ': $value = $this->decrypt($arOrder['mod_creditcard_typ']); break;
                case 'mod_creditcard_inhaber': $value = $this->decrypt($arOrder['mod_creditcard_inhaber']); break;
                case 'mod_creditcard_knr': $value = $this->decrypt($arOrder['mod_creditcard_knr']); break;
                case 'mod_creditcard_pruefz': $value = $this->decrypt($arOrder['mod_creditcard_pruefz']); break;
                case 'mod_creditcard_gueltigm': $value = $this->decrypt($arOrder['mod_creditcard_gueltigm']); break;
                case 'mod_creditcard_gueltigj': $value = $this->decrypt($arOrder['mod_creditcard_gueltigj']); break;

            }

			$return = $value;
			
		} // public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $order_product_id, $profil_separator)

        private function decrypt($string) {

            $arString = explode('|', $string);
            $key = $this->shop->get_option("wpsg_mod_creditcard_schluessel");
            $iv = $arString[0];
            $m = $arString[1];
            $t = implode('', array_slice($arString, 2));

            return openssl_decrypt($t, $m, $key, 0, $iv);

        }

	} // class wpsg_mod_creditcard extends wpsg_mod_basic
